$TITLE KOPOV TEST NA REALNE DATA
$offsymxref offsymlist offuelxref offuellist onlisting;
options limcol=0;
options limrow=0;
options decimals = 8;
options solprint = off;
*okienko urcuje kolko riadkovu maticu vyberam 120 riadkov po mesiaci = 10 rokov
parameter okienko /120/;
*skok urcuje kolko riadkov preskocim kym vyberiem dalsei okienko 12 riadkov = 1 rok
parameter skok /12/;
*mnozima indexov kolko ma aj okienko;
set t aktualna mnozina scenarov /1*120/;
set vysledkov /1 * 73/;
* indexy riadkov vybranej matice - je treba aby ich bolo tolko ako je velkost okienka
set riadky /riadok1 * riadok120/;
alias(riadky,ind);

parameter indexy(riadky)
                   /riadok1 1, riadok2 2, riadok3 3, riadok4 4, riadok5 5, riadok6 6, riadok7 7, riadok8 8, riadok9 9, riadok10 10, riadok11 11, riadok12 12, riadok13 13, riadok14 14, riadok15 15, riadok16 16, riadok17 17, riadok18 18, riadok19 19, riadok20 20, riadok21 21, riadok22 22, riadok23 23, riadok24 24, riadok25 25, riadok26 26, riadok27 27, riadok28 28, riadok29 29, riadok30 30, riadok31 31, riadok32 32, riadok33 33, riadok34 34, riadok35 35, riadok36 36, riadok37 37, riadok38 38, riadok39 39, riadok40 40, riadok41 41, riadok42 42, riadok43 43, riadok44 44, riadok45 45, riadok46 46, riadok47 47, riadok48 48, riadok49 49, riadok50 50, riadok51 51, riadok52 52, riadok53 53, riadok54 54, riadok55 55, riadok56 56, riadok57 57, riadok58 58, riadok59 59, riadok60 60, riadok61 61, riadok62 62, riadok63 63, riadok64 64, riadok65 65, riadok66 66, riadok67 67, riadok68 68, riadok69 69, riadok70 70, riadok71 71, riadok72 72, riadok73 73, riadok74 74, riadok75 75, riadok76 76, riadok77 77, riadok78 78, riadok79 79, riadok80 80, riadok81 81, riadok82 82, riadok83 83, riadok84 84, riadok85 85, riadok86 86, riadok87 87, riadok88 88, riadok89 89, riadok90 90, riadok91 91, riadok92 92, riadok93 93, riadok94 94, riadok95 95, riadok96 96, riadok97 97, riadok98 98, riadok99 99, riadok100 100, riadok101 101, riadok102 102, riadok103 103, riadok104 104, riadok105 105, riadok106 106, riadok107 107, riadok108 108, riadok109 109, riadok110 110, riadok111 111, riadok112 112, riadok113 113, riadok114 114, riadok115 115, riadok116 116, riadok117 117, riadok118 118, riadok119 119, riadok120 120/;

parameter te pocet scenarov v aktualnej ulohe;
te=card(riadky);

set scenare mnozina scenarov;
set aktiva mnozina aktiv;

* nacitanie dat z Excelu
$call Gdxxrw Industry_portfolios_upravene.xls set=scenare Rng=a2:a975 rdim=1 set=aktiva Rng=b1:l2 cdim=1 par=vynos Rng=a1:l975 cdim=1 rdim=1 par=tau Rng=a976 rdim=1
$gdxin Industry_portfolios_upravene.gdx
$load scenare
$load aktiva
parameter vynos(scenare, aktiva) nadvynosy v jednotlivych odvetviach = nadvynosy urcitych aktiv za platnosti scenarov;
$load vynos
parameter tau(scenare) nadvynosy trzneho portfolia;
$load tau
$gdxin

* pomocne parametre
parameter A(riadky);
parameter AIndex(riadky);
parameter y(riadky);
parameter B(t);
parameter AIndex2(t);
parameter z(t);

parameter matica(riadky,aktiva);
parameter xjtau(riadky) vektor vynosov pri t roznych scenaroch;
parameter matica2(t,aktiva);
parameter xjtau2(t) vektor vynosov pri t roznych scenaroch;


* zapis modelu ...
positive variables lambda(aktiva) vysledne SSD eficientne portfolio;
positive variables w(riadky, ind) matica W t krat t;
positive variables decka(riadky)  decka;
variables becka(riadky)  becka;

variable d hodnota ucelovej funkcie;
equations
   obmedzenieprve(riadky) prve obmedzenie v Kopovom teste;
equations
    obmedzeniedruhe(riadky,ind) druhe obmedzenie v Kopovom teste;
equations
   sucetlambda  sucet lambda je jedna;
equations d1 ucelova funkcia;

d1.. d =e= sum(riadky, decka(riadky));
obmedzenieprve(riadky).. y(riadky)+(1/(te-indexy(riadky)+1))*sum(t,z(t+indexy(riadky-1)))-(1/(te-indexy(riadky)+1))*(te-indexy(riadky)+1)*(y(riadky))-becka(riadky)-(1/(te-indexy(riadky)+1))*sum(ind,w(riadky,ind)) =g= decka(riadky);
obmedzeniedruhe(riadky,ind).. w(riadky, ind) =g= -sum(aktiva, matica(ind, aktiva)*lambda(aktiva))-becka(riadky);
sucetlambda..    sum(aktiva, lambda(aktiva)) =e= 1;

model kopa Kopov nutny a postacujuci test eficiencie portfolia tau /all/;

* pomocne parametre, ktore su potrebne pri vybere jednotlivych podmatic a riesenie ulohy pre tuto podmaticu
parameter vysledok(vysledkov);
parameter lambdavysl(vysledkov,aktiva);
parameter ktory;
parameter v;
parameter j;
parameter i;
parameter k;
v=0;
i=1;
while (i+okienko-1 <= card(scenare),
         ktory = i;
         j=0;
         loop(scenare,
               j=j+1;
               if (j=ktory,
                       k=0;
                       loop(riadky,
                               matica(riadky,aktiva) = vynos(scenare+k,aktiva);
                               xjtau(riadky) = -tau(scenare+k);
                               k=k+1;
                       );

               );
         );
         ktory = i;
         j=0;
         loop(scenare,
               j=j+1;
               if (j=ktory,
                       k=0;
                       loop(t,
                               matica2(t,aktiva) = vynos(scenare+k,aktiva);
                               xjtau2(t) = -tau(scenare+k);
                               k=k+1;
                       );

               );
         );
A(riadky) = xjtau(riadky);
* write symbol A to GDX file
execute_unload "rank_in.gdx", A;
* sort symbol; permutation index will be named A also
execute 'gdxrank rank_in.gdx rank_out.gdx';
* load the permutation index
execute_load "rank_out.gdx", AIndex=A;
* create a sorted version
y(riadky + (AIndex(riadky)- Ord(riadky))) = A(riadky);

B(t) = xjtau2(t);
execute_unload "rank_in.gdx", B;
* sort symbol; permutation index will be named A also
execute 'gdxrank rank_in.gdx rank_out.gdx';
* load the permutation index
execute_load "rank_out.gdx", AIndex2=B;
* create a sorted version
z(t + (AIndex2(t)- Ord(t))) = B(t);

solve kopa maximizing d using lp;
loop(vysledkov,vysledok(vysledkov+(i-1-(skok-1)*v))=d.l);
loop(vysledkov,lambdavysl(vysledkov+(i-1-(skok-1)*v),aktiva)=lambda.l(aktiva));
         i=i+skok;
         v=v+1;
);

* zapis vysledkov do Excelu
execute_unload "Kopa_miera.gdx" vysledok;
execute 'Gdxxrw.exe Kopa_miera.gdx par=vysledok Rng=a1';
execute_unload "Kopa_lambda.gdx"  lambdavysl;
execute 'Gdxxrw.exe Kopa_lambda.gdx par=lambdavysl Rng=a1';

